



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>sql 自定义函数--固定格式字符转时间类型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">sql 自定义函数--固定格式字符转时间类型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 13:12:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>遇到一个德国的客户，他们的时间格式是JJJJ-TT-DD HH:MM:SS,程序按照这个格式将时间插入数据库，但是在sql自带的转换函数convert、cast过程中报错，网上搜了下都说用convert、cast可以直接转换，但是这个客户的机器就是不行，没有办法自己写了个转换函数，供大家参考：</p>
<p>由于自定义函数里面不能直接使用getdate方法；所以先创建了个获取本地时间的小函数：</p>
<p>create view v_getdate as select getdate() as now_date</p>
<p>然后是转换函数：</p>
<div>
<pre class="prettyprint linenums"> CREATE  FUNCTION ToDateTime(@DateStr varchar(20))<br />
 RETURNS datetime<br />
 AS<br />
 BEGIN<br />
 declare @OutTime datetime<br />
 select @OutTime=now_date from v_getdate<br />
 if(len(@DateStr)&lt;20)<br />
   set @DateStr=substring(@DateStr+' 00:00:00',1,20)<br />
 set @OutTime=dateadd(year,0-year(@OutTime)+cast(substring(@DateStr,1,4) as int),@OutTime)<br />
 set @OutTime=dateadd(month,0-month(@OutTime)+cast(substring(@DateStr,6,2) as int),@OutTime)<br />
 set @OutTime=dateadd(day,0-day(@OutTime)+cast(substring(@DateStr,9,2) as int),@OutTime)<br />
 set @OutTime=dateadd(hour,0-DATEPART(HH,@OutTime)+cast(substring(@DateStr,12,2) as int),@OutTime)<br />
 set @OutTime=dateadd(minute,0-DATEPART(N,@OutTime)+cast(substring(@DateStr,15,2) as int),@OutTime)<br />
 set @OutTime=dateadd(second,0-DATEPART(S,@OutTime)+cast(substring(@DateStr,19,2) as int),@OutTime)<br />
 return @OutTime<br />
 END</pre>
</div>
<p>调用示例：select dbo.ToDateTime('2014-04-05 06:07:08')</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy4lkxq.html">X86 Booting Sequence</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93n3vgq.html">Convert Sorted List to Binary Search Tree &lbrack;LeetCode&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2zkvwq.html">Flask First Look</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvyj5jq.html">ElasticSearch 2 &lpar;10&rpar; - 在ElasticSearch之下（深入理解Shard和Lucene Index）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnn3l2q.html">53个要点提高PHP编程效率</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd1ep2q.html">mfs-管理员</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0d04wq.html">setjump 和 longjump</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k13j459.html">kafka学习&lpar;一&rpar;-背景及架构设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7znemg9.html">从CMOS到触发器（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp55g69.html">【Unity编程】Unity中的欧拉旋转</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gezy6z8.html">Elasticsearch 的分页报错 result window is too large</a>
		</li>
						<li><a href="https://www.batexi.com/a/95026we8.html">JSP的执行原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7e0g8.html">版本控制工具（SVN&sol;Git）介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r21268.html">Codeforces Round &num;382 &lpar;Div&period; 2&rpar; C&period; Tennis Championship</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvedjy8.html">【LOJ&num;10002】喷水装置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllrwkxq.html">&lbrack;MySQL&rsqb; 中 Schema和Database的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw20r79.html">ubuntu compile openjdk87</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd1gxd9.html">异步多线程 ASP&period;NET 同步调用异步 使用Result产生死锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve5wwx9.html">小程序swiper组件高度自适应【转载】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pym6eq.html">解决提交按钮在IE浏览器正常在360浏览器不可用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e1w3yx9.html">sqlserver 中的GUID 全局唯一标识 -摘自网络</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xdze08.html">对JDK&comma;JRE&comma;JVM的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnkre6q.html">homework-05</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xdy0z8.html">&lbrack;iOS UI进阶 - 3&period;1&rsqb; 触摸事件的传递</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vynn38.html">oracle 全文检索技术</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmg64e9.html">SOS 调试扩展 &lpar;SOS&period;dll&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z4xz49.html">java中动态代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1wkgz9.html">ssl配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvkmvyq.html">rsync服务架设&lpar;数据同步&vert;文件增量备份&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mdyvjq.html">skyline TerraExplorer fly设置相对路径的方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
